## talloc 2.1.7

=== wscript ===
#!/usr/bin/env python

APPNAME = 'talloc'
VERSION = '2.1.7'


blddir = 'bin'

import Logs
import os, sys

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = srcdir + '/..'
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import sys
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
import wafsamba, samba_dist, Options

# setup what directories to put in a tarball
samba_dist.DIST_DIRS("""lib/talloc:. lib/replace:lib/replace
buildtools:buildtools third_party/waf:third_party/waf""")


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('talloc', noextension='talloc')
    opt.RECURSE('lib/replace')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--enable-talloc-compat1',
                       help=("Build talloc 1.x.x compat library [False]"),
                       action="store_true", dest='TALLOC_COMPAT1', default=False)
        opt.add_option('--disable-python',
                       help=("disable the pytalloc module"),
                       action="store_true", dest='disable_python', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_talloc = conf.IN_LAUNCH_DIR()

    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    if not conf.env.standalone_talloc:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('talloc', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TALLOC', 1)
        if conf.CHECK_BUNDLED_SYSTEM_PKG('pytalloc-util', minversion=VERSION,
                                     implied_deps='talloc replace'):
            conf.define('USING_SYSTEM_PYTALLOC_UTIL', 1)

    conf.env.TALLOC_COMPAT1 = False
    if conf.env.standalone_talloc:
        conf.env.TALLOC_COMPAT1 = Options.options.TALLOC_COMPAT1

    conf.CHECK_XSLTPROC_MANPAGES()

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.SAMBA_CHECK_PYTHON(mandatory=False, version=(2,4,2))
        conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pytalloc-util as python devel libs not found')
            conf.env.disable_python = True

    conf.CHECK_HEADERS('sys/auxv.h')
    conf.CHECK_FUNCS('getauxval')

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()


def build(bld):
    bld.RECURSE('lib/replace')

    if bld.env.standalone_talloc:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.env.TALLOC_VERSION = VERSION
        private_library = False

        # should we also install the symlink to libtalloc1.so here?
        bld.SAMBA_LIBRARY('talloc-compat1-%s' % (VERSION),
                          'compat/talloc_compat1.c',
                          public_deps='talloc',
                          soname='libtalloc.so.1',
                          pc_files=[],
                          public_headers=[],
                          enabled=bld.env.TALLOC_COMPAT1)

        testsuite_deps = 'talloc'
        if bld.CONFIG_SET('HAVE_PTHREAD'):
            testsuite_deps += ' pthread'

        bld.SAMBA_BINARY('talloc_testsuite',
                         'testsuite_main.c testsuite.c',
                         testsuite_deps,
                         install=False)

        bld.SAMBA_BINARY('talloc_test_magic_differs_helper',
                         'test_magic_differs_helper.c',
                         'talloc', install=False)

    else:
        private_library = True

    if not bld.CONFIG_SET('USING_SYSTEM_TALLOC'):

        bld.SAMBA_LIBRARY('talloc',
                          'talloc.c',
                          deps='replace',
                          abi_directory='ABI',
                          abi_match='talloc* _talloc*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers=('' if private_library else 'talloc.h'),
                          pc_files='talloc.pc',
                          public_headers_install=not private_library,
                          private_library=private_library,
                          manpages='man/talloc.3')

    if not bld.CONFIG_SET('USING_SYSTEM_PYTALLOC_UTIL') and not bld.env.disable_python:
        for env in bld.gen_python_environments(['PKGCONFIGDIR']):
            name = bld.pyembed_libname('pytalloc-util')

            bld.SAMBA_LIBRARY(name,
                source='pytalloc_util.c',
                public_deps='talloc',
                pyembed=True,
                vnum=VERSION,
                hide_symbols=True,
                abi_directory='ABI',
                abi_match='pytalloc_* _pytalloc_*',
                private_library=private_library,
                public_headers=('' if private_library else 'pytalloc.h'),
                pc_files='pytalloc-util.pc'
                )
            bld.SAMBA_PYTHON('pytalloc',
                            'pytalloc.c',
                            deps='talloc ' + name,
                            enabled=True,
                            realname='talloc.so')

            bld.SAMBA_PYTHON('test_pytalloc',
                            'test_pytalloc.c',
                            deps='pytalloc',
                            enabled=True,
                            realname='_test_pytalloc.so',
                            install=False)


def test(ctx):
    '''run talloc testsuite'''
    import Utils, samba_utils
    cmd = os.path.join(Utils.g_module.blddir, 'talloc_testsuite')
    ret = samba_utils.RUN_COMMAND(cmd)
    print("testsuite returned %d" % ret)
    magic_helper_cmd = os.path.join(Utils.g_module.blddir, 'talloc_test_magic_differs_helper')
    magic_cmd = os.path.join(srcdir, 'lib', 'talloc',
                             'test_magic_differs.sh')

    magic_ret = samba_utils.RUN_COMMAND(magic_cmd + " " +  magic_helper_cmd)
    print("magic differs test returned %d" % magic_ret)
    pyret = samba_utils.RUN_PYTHON_TESTS(['test_pytalloc.py'])
    print("python testsuite returned %d" % pyret)
    sys.exit(ret or magic_ret or pyret)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)


def pydoctor(ctx):
    '''build python apidocs'''
    cmd='PYTHONPATH=bin/python pydoctor --project-name=talloc --project-url=http://talloc.samba.org/ --make-html --docformat=restructuredtext --introspect-c-modules --add-module bin/python/talloc.*'
    print("Running: %s" % cmd)
    os.system(cmd)

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = srcdir + '/..'
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist
import Options, Utils

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools third_party/waf:third_party/waf')

def set_options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@Utils.run_once
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('libaio.h locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('port.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h sys/fs/vx/quota.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h')

    if not conf.CHECK_DECLS('malloc', headers='stdlib.h'):
        conf.CHECK_HEADERS('malloc.h')

    conf.CHECK_HEADERS('grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('errno.h')
    conf.CHECK_HEADERS('getopt.h iconv.h')
    conf.CHECK_HEADERS('memory.h nss.h sasl/sasl.h')

    conf.CHECK_FUNCS_IN('inotify_init', 'inotify', checklibc=True,
                        headers='sys/inotify.h')

    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('aio.h sys/unistd.h rpc/rpc.h rpc/nettype.h alloca.h float.h')

    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h sys/sysctl.h')
    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_CODE('', headers='rpc/rpc.h rpcsvc/yp_prot.h', define='HAVE_RPCSVC_YP_PROT_H')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h valgrind/memcheck.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
    conf.CHECK_HEADERS('sys/atomic.h')
    conf.CHECK_HEADERS('libgen.h')

    # Check for process set name support
    conf.CHECK_CODE('''
                    #include <sys/prctl.h>
                    int main(void) {
                        prctl(0);
                        return 0;
                    }
                    ''',
                    'HAVE_PRCTL',
                    headers='sys/prctl.h',
                    msg='Checking for prctl syscall')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')
    conf.CHECK_FUNCS('sigsetmask siggetmask sigprocmask sigblock sigaction sigset')

    conf.CHECK_FUNCS_IN('''inet_ntoa inet_aton inet_ntop inet_pton connect gethostbyname
                           getaddrinfo getnameinfo freeaddrinfo gai_strerror socketpair''',
                        'socket nsl', checklibc=True,
                        headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
                           const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,
                                           (const void *)&val, sizeof(val));
                       }
                       ''',
                    define='HAVE_IPV6',
                    lib='nsl socket',
                    headers='sys/socket.h netdb.h netinet/in.h')

    if conf.CONFIG_SET('HAVE_SYS_UCONTEXT_H') and conf.CONFIG_SET('HAVE_SIGNAL_H'):
        conf.CHECK_CODE('''
                       ucontext_t uc;
                       sigaddset(&uc.uc_sigmask, SIGUSR1);
                       ''',
                       'HAVE_UCONTEXT_T',
                       msg="Checking whether we have ucontext_t",
                       headers='signal.h sys/ucontext.h')

    # Check for atomic builtins. */
    conf.CHECK_CODE('''
                    int i;
                    (void)__sync_fetch_and_add(&i, 1);
                    ''',
                    'HAVE___SYNC_FETCH_AND_ADD',
                    msg='Checking for __sync_fetch_and_add compiler builtin')

    conf.CHECK_CODE('''
                    int32_t i;
                    atomic_add_32(&i, 1);
                    ''',
                    'HAVE_ATOMIC_ADD_32',
                    headers='stdint.h sys/atomic.h',
                    msg='Checking for atomic_add_32 compiler builtin')

    # these may be builtins, so we need the link=False strategy
    conf.CHECK_FUNCS('strdup memmem printf memset memcpy memmove strcpy strncpy bzero', link=False)

    # See https://bugzilla.samba.org/show_bug.cgi?id=1097
    #
    # Ported in from autoconf where it was added with this commit:
    # commit 804cfb20a067b4b687089dc72a8271b3abf20f31
    # Author: Simo Sorce <idra@samba.org>
    # Date:   Wed Aug 25 14:24:16 2004 +0000
    #     r2070: Let's try to overload srnlen and strndup for AIX where they are natly broken.

    host_os = sys.platform
    if host_os.rfind('aix') > -1:
        conf.DEFINE('BROKEN_STRNLEN', 1)
        conf.DEFINE('BROKEN_STRNDUP', 1)

    conf.CHECK_FUNCS('shl_load shl_unload shl_findsym')
    conf.CHECK_FUNCS('pipe strftime srandom random srand rand usleep setbuffer')
    conf.CHECK_FUNCS('lstat getpgrp utime utimes setuid seteuid setreuid setresuid setgid setegid')
    conf.CHECK_FUNCS('setregid setresgid chroot strerror vsyslog setlinebuf mktime')
    conf.CHECK_FUNCS('ftruncate chsize rename waitpid wait4')
    conf.CHECK_FUNCS('initgroups pread pwrite strndup strcasestr strsep')
    conf.CHECK_FUNCS('strtok_r mkdtemp dup2 dprintf vdprintf isatty chown lchown')
    conf.CHECK_FUNCS('link readlink symlink realpath snprintf vsnprintf')
    conf.CHECK_FUNCS('asprintf vasprintf setenv unsetenv strnlen strtoull __strtoull')
    conf.CHECK_FUNCS('strtouq strtoll __strtoll strtoq memalign posix_memalign')

    if conf.CONFIG_SET('HAVE_MEMALIGN'):
        conf.CHECK_DECLS('memalign', headers='malloc.h')

    conf.CHECK_FUNCS('prctl dirname basename')

    # libbsd on some platforms provides strlcpy and strlcat
    if not conf.CHECK_FUNCS('strlcpy strlcat'):
        conf.CHECK_FUNCS_IN('strlcpy strlcat', 'bsd', headers='bsd/string.h',
                checklibc=True)
    if not conf.CHECK_FUNCS('getpeereid'):
        conf.CHECK_FUNCS_IN('getpeereid', 'bsd', headers='sys/types.h bsd/unistd.h')
    if not conf.CHECK_FUNCS_IN('setproctitle', 'setproctitle', headers='setproctitle.h'):
        conf.CHECK_FUNCS_IN('setproctitle', 'bsd', headers='sys/types.h bsd/unistd.h')

    conf.CHECK_CODE('''
                struct ucred cred;
                socklen_t cred_len;
                int ret = getsockopt(0, SOL_SOCKET, SO_PEERCRED, &cred, &cred_len);''',
                'HAVE_PEERCRED',

=== debian/changelog ===
talloc (2.1.7-1) unstable; urgency=medium

  * New upstream release.
  * Drop unnecessary dependency on python3-dev.
  * Bump standards version to 3.9.8 (no changes).

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 03 Jul 2016 19:51:49 +0000

talloc (2.1.6-1) unstable; urgency=low

  [ Jelmer Vernooij ]
  * Bump standards version to 3.9.7 (no changes).

  [ Andrew Bartlett ]
  * New upstream release.
  * Remove python3-talloc for now (trying to remove the SOABI caused other
    issues).

  [ Jelmer Vernooij ]
  * Fix Vcs-Git header to use master branch rather than unstable.
  * Add Breaks for older versions of python-samba (<< 2:4.3.6+dfsg-2), because
    of upstream bug https://bugzilla.samba.org/show_bug.cgi?id=11789.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 04 Apr 2016 07:53:47 +1200

=== debian/control ===
Source: talloc
Section: devel
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>, Christian Perrier <bubulle@debian.org>
Homepage: http://talloc.samba.org/
Build-Depends: debhelper (>= 9),
  docbook-xml, docbook-xsl, xsltproc,
  dh-exec,
  dh-python,
  libpopt-dev,
  python-dev (>= 2.6.6-3)
Standards-Version: 3.9.8
Vcs-Git: git://anonscm.debian.org/pkg-samba/talloc.git
XS-Testsuite: autopkgtest

Package: libtalloc2
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: hierarchical pool based memory allocator
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.

Package: libtalloc2-dbg
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Section: debug
Priority: extra
Depends: libtalloc2 (= ${binary:Version}), ${misc:Depends}
Architecture: any
Recommends: libc6-dbg
Description: hierarchical pool based memory allocator - debug symbols
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the debug symbols.

Package: libtalloc-dev
Section: libdevel
Depends: libtalloc2 (=${binary:Version}), ${misc:Depends}, pkg-config
Architecture: any
Description: hierarchical pool based memory allocator - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files.

Package: python-talloc
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: python
Provides: ${python:Provides}
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Breaks: python-samba (<< 2:4.3.6+dfsg-2)
Description: hierarchical pool based memory allocator - Python bindings
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the Python bindings.

Package: python-talloc-dbg
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-talloc (= ${binary:Version})
Recommends: python-dbg, libtalloc2-dbg
Priority: extra
Description: hierarchical pool based memory allocator - Python debug extension
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the Python debug extension.

Package: python-talloc-dev
Architecture: any
Section: libdevel
Depends: python-talloc (= ${binary:Version}), ${misc:Depends}, pkg-config
Description: talloc Python bindings - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files for the Python bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

CFLAGS += -g -Wall

DESTDIR=$(CURDIR)/debian/tmp

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

conf_args = --prefix=/usr --disable-rpath-install --disable-rpath --bundled-libraries=NONE
conf_args += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
conf_args += --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
conf_args += -v

export PYTHON="$(shell which `pyversions -d`)"

%:
	dh $* --parallel --with python2

override_dh_python2:
	dh_python2 --no-guessing-versions

override_dh_auto_configure:
	LDFLAGS="$(LDFLAGS)" PYTHON="$(PYTHON)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ./configure $(conf_args)

override_dh_auto_build:
	$(MAKE) all V=1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=bin/shared ./bin/talloc_testsuite
endif

override_dh_install:
	DEB_PY2_INCDIR=$(shell python-config --includes | sed 's,^-I\([^ ]*\).*,\1,') \
		dh_install --list-missing

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) distclean
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8854
	rm -f .lock-wscript
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8855
	rm -f buildtools/wafsamba/*.pyc \
		third_party/waf/wafadmin/*.pyc \
		third_party/waf/wafadmin/Tools/*.pyc \
		third_party/waf/wafadmin/3rdparty/*.pyc \

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(DESTDIR)
	# Waf really should be doing this:
	ar -rc libtalloc.a bin/default/talloc_*.o
	mv libtalloc.a $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip -plibtalloc2 --dbg-package=libtalloc2-dbg
	dh_strip -ppython-talloc --dbg-package=python-talloc-dbg

override_dh_makeshlibs:
	dh_makeshlibs -plibtalloc2 -- -c4
	dh_makeshlibs -ppython-talloc -Xtalloc. -- -c3

## talloc 2.1.8

=== debian/changelog ===
talloc (2.1.8-1) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Use https homepage for talloc.

  [ Mathieu Parent ]
  * New upstream release.
    - Update symbols (no change)
  * Add me to uploaders
  * Remove XS-Testsuite header in debian/control
  * Use secure Vcs-* uris
  * Fix copyright-refers-to-symlink-license
  * Enable all hardenings
  * Override dh-exec-subst-unknown-variable
  * Use https and verify upstream tarball from uscan
  * Use automatic debug packages (-dbgsym)

 -- Mathieu Parent <sathieu@debian.org>  Sat, 08 Oct 2016 23:16:09 +0200

## talloc 2.1.9

=== debian/changelog ===
talloc (2.1.9-2ubuntu1) artful; urgency=medium

  * python-talloc: Remove the dependency on the python interpreter.
    This allows installation of samba-libs on the desktop images without
    installing the python2 interpreter.  python-talloc isn't useful on
    it's own, and samba itself depends on python-samba pulling in
    python-talloc and the python interpreter again. Sure, a hack ...
  * python-talloc-dev: Add the dependencies removed from python-talloc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 21 Sep 2017 16:02:21 +0200

talloc (2.1.9-2) unstable; urgency=medium

  * Upload to unstable

 -- Mathieu Parent <sathieu@debian.org>  Mon, 19 Jun 2017 17:19:07 +0200

talloc (2.1.9-1) experimental; urgency=medium

  * New upstream version 2.1.9
  * Updating symbols

 -- Mathieu Parent <sathieu@debian.org>  Thu, 08 Jun 2017 22:41:31 +0200

=== debian/control ===
Source: talloc
Section: devel
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>, Christian Perrier <bubulle@debian.org>, Mathieu Parent <sathieu@debian.org>
Homepage: https://talloc.samba.org/
Build-Depends: debhelper (>= 9),
  docbook-xml, docbook-xsl, xsltproc,
  dh-exec,
  dh-python,
  libpopt-dev,
  python-dev (>= 2.6.6-3)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-samba/talloc.git
Vcs-Git: https://anonscm.debian.org/git/pkg-samba/talloc.git

Package: libtalloc2
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: hierarchical pool based memory allocator
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.

Package: libtalloc-dev
Section: libdevel
Depends: libtalloc2 (=${binary:Version}), ${misc:Depends}, pkg-config
Architecture: any
Description: hierarchical pool based memory allocator - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files.

Package: python-talloc
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: python
Provides: ${python:Provides}
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Breaks: python-samba (<< 2:4.3.6+dfsg-2)
Description: hierarchical pool based memory allocator - Python bindings
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the Python bindings.

Package: python-talloc-dev
Architecture: any
Section: libdevel
Depends: python-talloc (= ${binary:Version}), ${misc:Depends}, pkg-config, ${python:Depends}
Description: talloc Python bindings - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files for the Python bindings.

## talloc 2.1.10

=== wscript ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/env python
 
 APPNAME = 'talloc'
-VERSION = '2.1.7'
+VERSION = '2.1.10'
 
 
 blddir = 'bin'
@@ -32,9 +32,6 @@
         opt.add_option('--enable-talloc-compat1',
                        help=("Build talloc 1.x.x compat library [False]"),
                        action="store_true", dest='TALLOC_COMPAT1', default=False)
-        opt.add_option('--disable-python',
-                       help=("disable the pytalloc module"),
-                       action="store_true", dest='disable_python', default=False)
 
 
 def configure(conf):
@@ -42,21 +39,27 @@
 
     conf.env.standalone_talloc = conf.IN_LAUNCH_DIR()
 
-    conf.env.disable_python = getattr(Options.options, 'disable_python', False)
-
-    if not conf.env.standalone_talloc:
-        if conf.CHECK_BUNDLED_SYSTEM_PKG('talloc', minversion=VERSION,
-                                     implied_deps='replace'):
-            conf.define('USING_SYSTEM_TALLOC', 1)
-        if conf.CHECK_BUNDLED_SYSTEM_PKG('pytalloc-util', minversion=VERSION,
-                                     implied_deps='talloc replace'):
-            conf.define('USING_SYSTEM_PYTALLOC_UTIL', 1)
+    conf.define('TALLOC_BUILD_VERSION_MAJOR', int(VERSION.split('.')[0]))
+    conf.define('TALLOC_BUILD_VERSION_MINOR', int(VERSION.split('.')[1]))
+    conf.define('TALLOC_BUILD_VERSION_RELEASE', int(VERSION.split('.')[2]))
 
     conf.env.TALLOC_COMPAT1 = False
     if conf.env.standalone_talloc:
         conf.env.TALLOC_COMPAT1 = Options.options.TALLOC_COMPAT1
+        conf.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
+        conf.env.TALLOC_VERSION = VERSION
 
     conf.CHECK_XSLTPROC_MANPAGES()
+
+    conf.CHECK_HEADERS('sys/auxv.h')
+    conf.CHECK_FUNCS('getauxval')
+
+    conf.SAMBA_CONFIG_H()
+
+    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()
+
+    # We need to set everything non-python up before here, because
+    # SAMBA_CHECK_PYTHON makes a copy of conf and we need it set up correctly
 
     if not conf.env.disable_python:
         # also disable if we don't have the python libs installed
@@ -66,20 +69,32 @@
             Logs.warn('Disabling pytalloc-util as python devel libs not found')
             conf.env.disable_python = True
 
-    conf.CHECK_HEADERS('sys/auxv.h')
-    conf.CHECK_FUNCS('getauxval')
-
-    conf.SAMBA_CONFIG_H()
-
-    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()
+    if not conf.env.standalone_talloc:
+        if conf.CHECK_BUNDLED_SYSTEM_PKG('talloc', minversion=VERSION,
+                                     implied_deps='replace'):
+            conf.define('USING_SYSTEM_TALLOC', 1)
+
+        using_system_pytalloc_util = True
+        if not conf.CHECK_BUNDLED_SYSTEM_PKG('pytalloc-util', minversion=VERSION,
+                                             implied_deps='talloc replace'):
+            using_system_pytalloc_util = False
+
+        # We need to get a pytalloc-util for all the python versions
+        # we are building for
+        if conf.env['EXTRA_PYTHON']:
+            name = 'pytalloc-util' + conf.all_envs['extrapython']['PYTHON_SO_ABI_FLAG']
+            if not conf.CHECK_BUNDLED_SYSTEM_PKG(name, minversion=VERSION,
+                                                 implied_deps='talloc replace'):
+                using_system_pytalloc_util = False
+
+        if using_system_pytalloc_util:
+            conf.define('USING_SYSTEM_PYTALLOC_UTIL', 1)
 
 
 def build(bld):
     bld.RECURSE('lib/replace')
 
     if bld.env.standalone_talloc:
-        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
-        bld.env.TALLOC_VERSION = VERSION
         private_library = False
 
         # should we also install the symlink to libtalloc1.so here?
@@ -122,7 +137,7 @@
                           private_library=private_library,
                           manpages='man/talloc.3')
 
-    if not bld.CONFIG_SET('USING_SYSTEM_PYTALLOC_UTIL') and not bld.env.disable_python:
+    if not bld.CONFIG_SET('USING_SYSTEM_PYTALLOC_UTIL'):
         for env in bld.gen_python_environments(['PKGCONFIGDIR']):
             name = bld.pyembed_libname('pytalloc-util')
 
@@ -136,18 +151,19 @@
                 abi_match='pytalloc_* _pytalloc_*',
                 private_library=private_library,
                 public_headers=('' if private_library else 'pytalloc.h'),
-                pc_files='pytalloc-util.pc'
+                pc_files='pytalloc-util.pc',
+                enabled=bld.PYTHON_BUILD_IS_ENABLED()
                 )
             bld.SAMBA_PYTHON('pytalloc',
                             'pytalloc.c',
                             deps='talloc ' + name,
-                            enabled=True,
+                            enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                             realname='talloc.so')
 
             bld.SAMBA_PYTHON('test_pytalloc',
                             'test_pytalloc.c',
                             deps='pytalloc',
-                            enabled=True,
+                            enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                             realname='_test_pytalloc.so',
                             install=False)
 
@@ -155,12 +171,18 @@
 def test(ctx):
     '''run talloc testsuite'''
     import Utils, samba_utils
+
+    samba_utils.ADD_LD_LIBRARY_PATH('bin/shared')
+    samba_utils.ADD_LD_LIBRARY_PATH('bin/shared/private')
+
     cmd = os.path.join(Utils.g_module.blddir, 'talloc_testsuite')
     ret = samba_utils.RUN_COMMAND(cmd)
     print("testsuite returned %d" % ret)
     magic_helper_cmd = os.path.join(Utils.g_module.blddir, 'talloc_test_magic_differs_helper')
     magic_cmd = os.path.join(srcdir, 'lib', 'talloc',
                              'test_magic_differs.sh')
+    if not os.path.exists(magic_cmd):
+        magic_cmd = os.path.join(srcdir, 'test_magic_differs.sh')
 
     magic_ret = samba_utils.RUN_COMMAND(magic_cmd + " " +  magic_helper_cmd)
     print("magic differs test returned %d" % magic_ret)

=== lib/replace/wscript ===
--- 
+++ 
@@ -80,6 +80,9 @@
     conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
     conf.CHECK_HEADERS('sys/atomic.h')
     conf.CHECK_HEADERS('libgen.h')
+
+    if conf.CHECK_CFLAGS('-Wno-format-truncation'):
+        conf.define('HAVE_WNO_FORMAT_TRUNCATION', '1')
 
     # Check for process set name support
     conf.CHECK_CODE('''
@@ -189,7 +192,7 @@
                        ''',
                     define='HAVE_IPV6',
                     lib='nsl socket',
-                    headers='sys/socket.h netdb.h netinet/in.h')
+                    headers='sys/socket.h netdb.h netinet/in.h net/if.h')
 
     if conf.CONFIG_SET('HAVE_SYS_UCONTEXT_H') and conf.CONFIG_SET('HAVE_SIGNAL_H'):
         conf.CHECK_CODE('''
@@ -257,8 +260,7 @@
     if not conf.CHECK_FUNCS_IN('setproctitle', 'setproctitle', headers='setproctitle.h'):
         conf.CHECK_FUNCS_IN('setproctitle', 'bsd', headers='sys/types.h bsd/unistd.h')
 
-    conf.CHECK_CODE('''
-                struct ucred cred;
-                socklen_t cred_len;
-                int ret = getsockopt(0, SOL_SOCKET, SO_PEERCRED, &cred, &cred_len);''',
-                'HAVE_PEERCRED',
+    if not conf.CHECK_FUNCS('closefrom'):
+        conf.CHECK_FUNCS_IN('closefrom', 'bsd', headers='bsd/unistd.h')
+
+    conf.CHECK_CODE('''

=== debian/changelog ===
talloc (2.1.10-2ubuntu1) bionic; urgency=medium

  * Merge with Debian; remaiing changes:
    - python-talloc: Remove the dependency on the python interpreter.
      This allows installation of samba-libs on the desktop images without
      installing the python2 interpreter.  python-talloc isn't useful on
      it's own, and samba itself depends on python-samba pulling in
      python-talloc and the python interpreter again. Sure, a hack ...
    - python-talloc-dev: Add the dependencies removed from python-talloc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 09 Nov 2017 12:42:52 +0100

talloc (2.1.10-2) unstable; urgency=medium

  * Upload to sid

 -- Mathieu Parent <sathieu@debian.org>  Thu, 26 Oct 2017 10:25:44 +0200

talloc (2.1.10-1) experimental; urgency=medium

  * New upstream version 2.1.10
    - Update symbols (no change)
  * Use https form of the copyright-format URL (Debian Policy 4.0.0)
  * Standards-Version: 4.0.0

 -- Mathieu Parent <sathieu@debian.org>  Thu, 28 Sep 2017 23:08:38 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
   dh-python,
   libpopt-dev,
   python-dev (>= 2.6.6-3)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-samba/talloc.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-samba/talloc.git

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
@@ -25,6 +26,10 @@
 
 override_dh_python2:
 	dh_python2 --no-guessing-versions
+	: # this is a hack ... to keep python off the desktop image
+	-grep '^python:Depends=' \
+	  debian/python-talloc.substvars >> debian/python-talloc-dev.substvars
+	sed -i -e '/^python:Depends=/d' debian/python-talloc.substvars
 
 override_dh_auto_configure:
 	LDFLAGS="$(LDFLAGS)" PYTHON="$(PYTHON)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ./configure $(conf_args)
@@ -63,8 +68,7 @@
 	mv libtalloc.a $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_strip:
-	dh_strip -plibtalloc2 --dbg-package=libtalloc2-dbg
-	dh_strip -ppython-talloc --dbg-package=python-talloc-dbg
+	dh_strip --dbgsym-migration='libtalloc2-dbg (<< 2.1.8-1~), python-talloc-dbg (<< 2.1.8-1~)'
 
 override_dh_makeshlibs:
 	dh_makeshlibs -plibtalloc2 -- -c4

## talloc 2.1.14

=== debian/changelog ===
talloc (2.1.14-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 19:28:53 +0800

talloc (2.1.14-2) unstable; urgency=medium

  * Add debian/upstream/metadata.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Tue, 23 Oct 2018 09:22:43 +0000

talloc (2.1.14-1) unstable; urgency=medium

  * Upload to unstable
    - Update symbols, no change
  * New upstream version 2.1.14
  * Revert python3 support (Reopen #802484, #814928; Closes: #902883) until it
    is ready
  * Add Breaks: python3-talloc (<< 2.1.13-2~)
  * Standards-Version: 4.1.5:
    - Add Rules-Requires-Root: no

 -- Mathieu Parent <sathieu@debian.org>  Sat, 14 Jul 2018 22:28:35 +0200

talloc (2.1.13-1) experimental; urgency=medium

  [ Timo Aaltonen ]
  * Add py3 support back (Closes: #802484, #814928)

  [ Mathieu Parent ]
  * New upstream version 2.1.13
    - Update symbols (no change)
  * Update Standards-Version to 4.1.4, no change
  * Mark libtalloc-dev and python{,3}-talloc{,dev} "Multi-Arch: same"
  * Run wrap-and-sort
  * Drop d/patches/series (pytalloc-util-name.diff missing)
  * Fix lintian overrides
  * Upload to experimental, as python3 changes are risky

 -- Mathieu Parent <sathieu@debian.org>  Sun, 01 Jul 2018 09:28:27 +0200

talloc (2.1.11-2) unstable; urgency=low

  * Upload to unstable

 -- Mathieu Parent <sathieu@debian.org>  Tue, 15 May 2018 15:40:10 +0200

talloc (2.1.11-1) experimental; urgency=medium

  * New upstream version 2.1.11
    - Update symbols (no change)
  * Upload to experimental
  * Repository moved to salsa: Update Vcs-* fields
  * Fix global-files-wildcard-not-first-paragraph-in-dep5-copyright
  * Move to debhelper 11, no expected change
    - remove "dh --parallel", not needed in compat 11
  * Standards-Version: 4.1.3, no change

 -- Mathieu Parent <sathieu@debian.org>  Sun, 11 Mar 2018 21:04:04 +0100

=== debian/control ===
Source: talloc
Section: devel
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Christian Perrier <bubulle@debian.org>,
           Mathieu Parent <sathieu@debian.org>
Homepage: https://talloc.samba.org/
Build-Depends: debhelper (>= 11),
               dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               libpopt-dev,
               python-dev (>= 2.6.6-3),
               xsltproc
Rules-Requires-Root: no
Standards-Version: 4.1.5
Vcs-Browser: https://salsa.debian.org/samba-team/talloc
Vcs-Git: https://salsa.debian.org/samba-team/talloc.git

Package: libtalloc2
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: python3-talloc (<< 2.1.13-2~)
Section: libs
Description: hierarchical pool based memory allocator
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.

Package: libtalloc-dev
Section: libdevel
Depends: libtalloc2 (=${binary:Version}), pkg-config, ${misc:Depends}
Architecture: any
Multi-Arch: same
Description: hierarchical pool based memory allocator - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files.

Package: python-talloc
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Multi-Arch: same
Section: python
Provides: ${python:Provides}
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Breaks: python-samba (<< 2:4.3.6+dfsg-2)
Description: hierarchical pool based memory allocator - Python bindings
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the Python bindings.

Package: python-talloc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: pkg-config, python-talloc (= ${binary:Version}), ${misc:Depends}
Description: talloc Python bindings - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files for the Python bindings.

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress" \
https://download.samba.org/pub/talloc/ talloc-(.+).tar.gz

## talloc 2.1.16

=== debian/changelog ===
talloc (2.1.16-2) experimental; urgency=medium

  * d/copyright Full review

 -- Mathieu Parent <sathieu@debian.org>  Mon, 29 Jul 2019 23:23:19 +0200

talloc (2.1.16-1) experimental; urgency=medium

  [ Mathieu Parent ]
  * New upstream version 2.1.16
    - Update symbols, no change
    - Clean up third_party/waf/waflib/*.pyc in override_dh_auto_clean
  * Add Debian pipeline (debian/gitlab-ci.yml)
  * Lintian:
    - Fix public-upstream-key-not-minimal
    - Standards-Version: 4.2.1
    - Add Build-Depends-Package field in d/*.symbols
    - debian/python-talloc.lintian-overrides: Override false-positive
      library-not-linked-against-libc
    - Standards-Version: 4.3.0
    - Add Build-Depends-Package: python3-talloc-dev to
      python3-talloc.symbols.common
    - Add python3-talloc{,-dev}.lintian-overrides
  * Remove undefined ${python:Depends} form python3-talloc-dev Depends

  [ Andreas Hasenack ]
  *  d/rules: fix globbing for talloc static library creation
  *  d/rules: build for python2 and python3
  *  d/control, d/python3-talloc.install: new python3 binding package
  *  d/python3-talloc.symbols.{common,amd64,armhf,arm64,s390x,ppc64el,i386}: use
     per-arch symbols file
  *  d/rules: check python3-talloc symbols
  *  d/control, d/python3-talloc-dev.install, d/rules: new python3-talloc-dev
     package

 -- Mathieu Parent <sathieu@debian.org>  Sat, 23 Mar 2019 09:10:08 +0100

=== debian/control ===
--- 
+++ 
@@ -13,9 +13,10 @@
                docbook-xsl,
                libpopt-dev,
                python-dev (>= 2.6.6-3),
+               python3-dev,
                xsltproc
 Rules-Requires-Root: no
-Standards-Version: 4.1.5
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/samba-team/talloc
 Vcs-Git: https://salsa.debian.org/samba-team/talloc.git
 
@@ -41,6 +42,31 @@
  .
  This package contains the development files.
 
+Package: python3-talloc
+Section: python
+Architecture: linux-any kfreebsd-any
+Depends: libtalloc2 (= ${binary:Version}),
+         ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends}
+Provides: ${python3:Provides}
+Description: hierarchical pool based memory allocator - Python3 bindings
+ A hierarchical pool based memory allocator with destructors. It uses
+ reference counting to determine when memory should be freed.
+ .
+ This package contains the Python 3 bindings.
+
+Package: python3-talloc-dev
+Architecture: any
+Multi-Arch: same
+Section: libdevel
+Depends: pkg-config, python3-talloc (= ${binary:Version}), ${misc:Depends}
+Description: talloc Python 3 bindings - development files
+ A hierarchical pool based memory allocator with destructors. It uses
+ reference counting to determine when memory should be freed.
+ .
+ This package contains the development files for the Python 3 bindings.
+
 Package: python-talloc
 Pre-Depends: ${misc:Pre-Depends}
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -17,22 +17,19 @@
 conf_args = --prefix=/usr --disable-rpath-install --disable-rpath --bundled-libraries=NONE
 conf_args += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
 conf_args += --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
+conf_args += --extra-python=python2
 conf_args += -v
 
 export PYTHON="$(shell which `pyversions -d`)"
 
 %:
-	dh $* --parallel --with python2
+	dh $* --with python2,python3
 
 override_dh_python2:
 	dh_python2 --no-guessing-versions
-	: # this is a hack ... to keep python off the desktop image
-	-grep '^python:Depends=' \
-	  debian/python-talloc.substvars >> debian/python-talloc-dev.substvars
-	sed -i -e '/^python:Depends=/d' debian/python-talloc.substvars
 
 override_dh_auto_configure:
-	LDFLAGS="$(LDFLAGS)" PYTHON="$(PYTHON)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ./configure $(conf_args)
+	LDFLAGS="$(LDFLAGS)" PYTHON="" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ./configure $(conf_args)
 
 override_dh_auto_build:
 	$(MAKE) all V=1
@@ -44,6 +41,7 @@
 
 override_dh_install:
 	DEB_PY2_INCDIR=$(shell python-config --includes | sed 's,^-I\([^ ]*\).*,\1,') \
+	DEB_PY3_INCDIR=$(shell python3-config --includes | sed 's,^-I\([^ ]*\).*,\1,') \
 		dh_install --list-missing
 
 get-packaged-orig-source:
@@ -60,16 +58,17 @@
 		third_party/waf/wafadmin/*.pyc \
 		third_party/waf/wafadmin/Tools/*.pyc \
 		third_party/waf/wafadmin/3rdparty/*.pyc \
+		third_party/waf/waflib/*.pyc \
+		third_party/waf/waflib/*/*.pyc \
+
 
 override_dh_auto_install:
 	$(MAKE) install DESTDIR=$(DESTDIR)
 	# Waf really should be doing this:
-	ar -rc libtalloc.a bin/default/talloc_*.o
+	ar -rc libtalloc.a bin/default/talloc*.o
 	mv libtalloc.a $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
-
-override_dh_strip:
-	dh_strip --dbgsym-migration='libtalloc2-dbg (<< 2.1.8-1~), python-talloc-dbg (<< 2.1.8-1~)'
 
 override_dh_makeshlibs:
 	dh_makeshlibs -plibtalloc2 -- -c4
 	dh_makeshlibs -ppython-talloc -Xtalloc. -- -c3
+	dh_makeshlibs -ppython3-talloc -Xtalloc. -- -c3

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress" \
https://download.samba.org/pub/talloc/ talloc-(2\.1\..+).tar.gz
